// LCMailerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "LCMailer.h"
#include "LCMailerDlg.h"
#include "ServerSetup.h"
#include "SendDlg.h"
#include "Attachment.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

	//Ի
	CLCMailerDlg *m_pLCMailerDlg;

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CMacButton	m_ctrlMailMe;
	CMacButton	m_ctrlHomepage;
	CMacButton	m_OK;
	CStarWarsCtrl	m_StarWarsCtrl;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnButtonMailme();
	afx_msg void OnButtonHomepage();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Control(pDX, IDC_BUTTON_MAILME, m_ctrlMailMe);
	DDX_Control(pDX, IDC_BUTTON_HOMEPAGE, m_ctrlHomepage);
	DDX_Control(pDX, IDOK, m_OK);
	DDX_Control(pDX, IDC_STATIC_STARWAR, m_StarWarsCtrl);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	ON_BN_CLICKED(IDC_BUTTON_MAILME, OnButtonMailme)
	ON_BN_CLICKED(IDC_BUTTON_HOMEPAGE, OnButtonHomepage)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLCMailerDlg dialog

CLCMailerDlg::CLCMailerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLCMailerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CLCMailerDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CLCMailerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLCMailerDlg)
	DDX_Control(pDX, IDC_EDIT_BODY, m_ctrlBody);
	DDX_Control(pDX, IDC_EDIT_SUBJECT, m_ctrlSubject);
	DDX_Control(pDX, IDC_EDIT_MAILTO, m_ctrlTo);
	DDX_Control(pDX, IDC_BUTTON_SERVERSETUP, m_ctrlServerSetup);
	DDX_Control(pDX, IDC_BUTTON_SEND, m_ctrlSend);
	DDX_Control(pDX, IDC_BUTTON_EXIT, m_ctrlExit);
	DDX_Control(pDX, IDC_BUTTON_ATTACHMENT, m_ctrlAttachment);
	DDX_Control(pDX, IDC_BUTTON_ABOUT, m_ctrlAbout);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CLCMailerDlg, CDialog)
	//{{AFX_MSG_MAP(CLCMailerDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_SERVERSETUP, OnButtonServerSetup)
	ON_BN_CLICKED(IDC_BUTTON_ABOUT, OnButtonAbout)
	ON_BN_CLICKED(IDC_BUTTON_EXIT, OnButtonExit)
	ON_BN_CLICKED(IDC_BUTTON_SEND, OnButtonSend)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_ATTACHMENT, OnButtonAttachment)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLCMailerDlg message handlers

BOOL CLCMailerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	//ʼiniļ·
	GetCurrentDirectory(MAX_PATH, szIniFile.GetBuffer(10));
	szIniFile = szIniFile.GetBuffer(10);
	szIniFile += "\\LCMailer.ini";

	//ʼNeedAuth״̬
	m_nNeedAuth.Format("%d", GetPrivateProfileInt("Server Options", "Need ESMTP", 0, szIniFile));

	//롰SMTPݣ
	GetPrivateProfileString("Server Options", "Server Name", "", m_szServerName.GetBuffer(10), 15, szIniFile);

	//롰˿ڡݣ
	m_nPort.Format("%d", GetPrivateProfileInt("Server Options", "Port", 25, szIniFile));
	
	//롰ûʺšݣ
	GetPrivateProfileString("Server Options", "Data1", "", m_szAccount.GetBuffer(10), 100, szIniFile);

	//롰û롱ݣ
	GetPrivateProfileString("Server Options", "Data2", "", m_szPassword.GetBuffer(10), 100, szIniFile);

	//롰䡱ݣ
	GetPrivateProfileString("User Info", "Mail From", "", m_szFrom.GetBuffer(10), 100, szIniFile);

	//롰ݣ
	GetPrivateProfileString("User Info", "Username", "", m_szUsername.GetBuffer(10), 100, szIniFile);

	szIniFile.ReleaseBuffer();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CLCMailerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CLCMailerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CLCMailerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CLCMailerDlg::OnButtonServerSetup() 
{
	// TODO: Add your control notification handler code here
	CServerSetup hSetupDlg;
	hSetupDlg.m_pLCMailerDlg = this;
	hSetupDlg.DoModal();
}

BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here

	//áStarWarǺǡ
	m_StarWarsCtrl.SetStarSpeed(30);
	m_StarWarsCtrl.SetScrollSpeed(2);
	m_StarWarsCtrl.AddTextLine("ܾúܾǰ");
	m_StarWarsCtrl.AddTextLine("");
	m_StarWarsCtrl.AddTextLine("ңԶϵ");
	m_StarWarsCtrl.AddTextLine("");
	m_StarWarsCtrl.AddTextLine("");
	m_StarWarsCtrl.AddTextLine("");
	m_StarWarsCtrl.AddTextLine("޴ ");
	m_StarWarsCtrl.AddTextLine("");
	m_StarWarsCtrl.AddTextLine("LCMailer v1.0");
	m_StarWarsCtrl.AddTextLine("");
	m_StarWarsCtrl.AddTextLine("");
	m_StarWarsCtrl.AddTextLine("");
	m_StarWarsCtrl.AddTextLine("ǻԶסһ");
	m_StarWarsCtrl.AddTextLine("");
	m_StarWarsCtrl.AddTextLine("20021018");
	m_StarWarsCtrl.AddTextLine("");
	m_StarWarsCtrl.AddTextLine("");
	m_StarWarsCtrl.AddTextLine("");
	m_StarWarsCtrl.AddTextLine("ַ");
	m_StarWarsCtrl.AddTextLine("");
	m_StarWarsCtrl.AddTextLine("http://www.luocong.com");
	m_StarWarsCtrl.AddTextLine("");
	m_StarWarsCtrl.AddTextLine("");
	m_StarWarsCtrl.AddTextLine("");
	m_StarWarsCtrl.AddTextLine("");
	m_StarWarsCtrl.AddTextLine("");
	m_StarWarsCtrl.AddTextLine("");
	m_StarWarsCtrl.AddTextLine("Ըԭͬڡ");

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CLCMailerDlg::OnButtonAbout() 
{
	// TODO: Add your control notification handler code here
	CAboutDlg hDlg;
	hDlg.m_pLCMailerDlg = this;
	hDlg.DoModal();
}

void CLCMailerDlg::OnButtonExit() 
{
	// TODO: Add your control notification handler code here
	PostQuitMessage(0);
}

BOOL CLCMailerDlg::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	//IDOKIDCANCELϢ
	if(pMsg->message == WM_KEYDOWN && pMsg->wParam == VK_RETURN || pMsg->wParam == VK_ESCAPE)
	{
		CWnd *hWnd = FromHandle(pMsg->hwnd);
		char ClassName[16];
		if(GetClassName(hWnd->GetSafeHwnd(), ClassName, sizeof(ClassName)) != 0)
		{
			DWORD style = ::GetWindowLong(pMsg->hwnd, GWL_STYLE);
			if((style & ES_MULTILINE) == 0)
			{
				if(strnicmp(ClassName, "EDIT", 5) == 0)
				{
					return TRUE;
				}
			}
		}
	}
	
	return CDialog::PreTranslateMessage(pMsg);
}

void CLCMailerDlg::OnButtonSend() 
{
	// TODO: Add your control notification handler code here

	CString szBuf;

	CSendDlg hSendDlg;
	hSendDlg.m_nCopyNumber = 1;

	m_ctrlTo.GetWindowText(szBuf);
	if(szBuf.IsEmpty())
	{
		MessageBox("д䣡", "", MB_OK | MB_ICONHAND);
		m_ctrlTo.SetFocus();
		return;
	}

	//SMTP
	hSendDlg.m_strSmtpServer = m_szServerName;

	//˿ڡ
	hSendDlg.m_nPort = atoi(m_nPort);

	//ûʺš
	hSendDlg.m_strAccount = m_szAccount;

	//û롱
	hSendDlg.m_strPassword = m_szPassword;

	//ˡ
	hSendDlg.m_strFrom = m_szFrom;

	//û
	hSendDlg.m_strUsername = m_szUsername;

	//ˡ
	m_ctrlTo.GetWindowText(szBuf);
	hSendDlg.m_strTo = szBuf;

	//⡱
	m_ctrlSubject.GetWindowText(szBuf);
	hSendDlg.m_strSubject = szBuf;

	//ġ
	m_ctrlBody.GetWindowText(szBuf);
	hSendDlg.m_strBody = szBuf;

	//ļб
	hSendDlg.m_szFilenames.Copy(m_szFilenames);

	//ǷҪ֤
	hSendDlg.m_bNeedAuth = atoi(m_nNeedAuth);
	
	//ʽͣ
	hSendDlg.DoModal();

	//㡱
	m_ctrlTo.SetWindowText("");
	m_ctrlSubject.SetWindowText("");
	m_ctrlBody.SetWindowText("");
	m_szFilenames.RemoveAll();
	m_ctrlTo.SetFocus();

}

void CLCMailerDlg::OnDestroy() 
{
	CDialog::OnDestroy();

	//SMTPдiniļУ
	//m_ctrlServerName.GetWindowText(m_szServerName);
	WritePrivateProfileString("Server Options", "Server Name", m_szServerName, szIniFile);

	//˿ڡдiniļУ
	//m_ctrlPort.GetWindowText(m_iPort);
	WritePrivateProfileString("Server Options", "Port", m_nPort, szIniFile);

	//NeedAuth״̬дiniļУ
	WritePrivateProfileString("Server Options", "Need ESMTP", m_nNeedAuth, szIniFile);

	//ûʺšдiniļУ
	//m_ctrlAccount.GetWindowText(m_szAccount);
	WritePrivateProfileString("Server Options", "Data1", m_szAccount, szIniFile);

	//û롱дiniļУ
	//m_ctrlPassword.GetWindowText(m_szPassword);
	WritePrivateProfileString("Server Options", "Data2", m_szPassword, szIniFile);

	//䡱дiniļУ
	//m_ctrlFrom.GetWindowText(m_szFrom);
	WritePrivateProfileString("User Info", "Mail From", m_szFrom, szIniFile);

	//дiniļУ
	//m_ctrlUsername.GetWindowText(m_szUsername);
	WritePrivateProfileString("User Info", "Username", m_szUsername, szIniFile);
	
	// TODO: Add your message handler code here
	
}

void CLCMailerDlg::OnButtonAttachment() 
{
	// TODO: Add your control notification handler code here
	CAttachment hAttachmentDlg;
	hAttachmentDlg.m_pLCMailerDlg = this;
	hAttachmentDlg.DoModal();
}

void CAboutDlg::OnButtonMailme() 
{
	// TODO: Add your control notification handler code here

	//дŸң
	//ShellExecute(this->m_hWnd, "open", "mailto:lcother@163.net", NULL, NULL, SW_SHOWNORMAL);
	m_pLCMailerDlg->m_ctrlTo.SetWindowText("lcother@163.net");
	m_pLCMailerDlg->m_ctrlSubject.SetWindowText("ޣãʹ LCMailer v1.0");
	CAboutDlg::OnOK();
}

void CAboutDlg::OnButtonHomepage() 
{
	// TODO: Add your control notification handler code here
	
	//ҵҳ
	ShellExecute(this->m_hWnd, "open", "http://www.luocong.com", NULL, NULL, SW_SHOWNORMAL);
}
