#include "StdAfx.h"
#include "SMTP.h"
#include "Base64.h"

CSMTP::response_code CSMTP::response_table[] =
{
	//GENERIC_SUCCESS
	{250, _T("SMTP ")},
	//AUTHLOGIN_SUCCESS
	{334, _T("SMTP ֤Ӵ")},
	//AUTH_SUCCESS
	{235, _T("SMTP û/֤")},
	//CONNECT_SUCCESS
	{220, _T("SMTP ")},
	//DATA_SUCCESS
	{354, _T("SMTP ܽ")},
	//QUIT_SUCCESS
	{221, _T("SMTP ûֹỰ")}
};

CSMTP::CSMTP(LPCTSTR szSMTPServerName, UINT nPort)
{
	ASSERT(szSMTPServerName != NULL);
	AfxSocketInit();
	m_sSMTPServerHostName = szSMTPServerName;
	m_nPort = nPort;
	m_bConnected = FALSE;
	m_sError = _T("OK");
	response_buf = NULL;
}

CSMTP::~CSMTP()
{
	Disconnect();
}

//****************************************
// ܣӷ
//****************************************
BOOL CSMTP::Connect()
{
	if(m_bConnected)
		return TRUE;
	
	try
	{
		response_buf = new TCHAR[RESPONSE_BUFFER_SIZE];
		if(response_buf == NULL)
		{
			m_sError = _T("ڴ治㣡");
			return FALSE;
		}
	}
	catch(CException *e)
	{
		response_buf = NULL;
		m_sError = _T("ڴ治㣡");
		delete e;
		return FALSE;
	}

	if(!m_wsSMTPServer.Create())
	{
		m_sError = _T("޷׽֣");
		delete response_buf;
		response_buf = NULL;
		return FALSE;
	}

	if(!m_wsSMTPServer.Connect(GetServerHostName(), GetPort()))
	{
		m_sError = _T("޷ӵ");
		m_wsSMTPServer.Close();
		delete response_buf;
		response_buf = NULL;
		return FALSE;
	}

	if(!get_response(CONNECT_SUCCESS))
	{
		m_sError = _T("ûӦ");
		m_wsSMTPServer.Close();
		delete response_buf;
		response_buf = NULL;
		return FALSE;
	}

	//͡EHLO %SMTP-Server Name%
	CString szHello;
	szHello.Format(_T("EHLO %s\r\n"), m_sSMTPServerHostName);
	m_wsSMTPServer.Send((LPCTSTR)szHello, szHello.GetLength());
	if(!get_response(GENERIC_SUCCESS))
	{
		m_sError = _T("޷ӵ");
		m_wsSMTPServer.Close();
		delete response_buf;
		response_buf = NULL;
		return FALSE;
	}

	m_bConnected = TRUE;
	return TRUE;
}

//****************************************
// ܣ֤
//****************************************
BOOL CSMTP::Auth()
{
	CString szAccount;
	CString szPassword;
	CBase64 Base64;

	if(!m_bConnected)
	{
		m_sError = _T("ȴӣ");
		return FALSE;
	}

	//͡AUTH LOGIN
	m_wsSMTPServer.Send(_T("AUTH LOGIN\r\n"), lstrlen(_T("AUTH LOGIN\r\n")));
	if(!get_response(AUTHLOGIN_SUCCESS))
	{
		m_wsSMTPServer.Close();
		delete response_buf;
		response_buf = NULL;
		return FALSE;
	}

	//;Base64ûʺţ
	szAccount.Format("%s\r\n", Base64.Encode(m_strAccount, lstrlen(m_strAccount)));
	m_wsSMTPServer.Send((LPCTSTR)szAccount, szAccount.GetLength());
	if(!get_response(AUTHLOGIN_SUCCESS))
	{
		m_wsSMTPServer.Close();
		delete response_buf;
		response_buf = NULL;
		return FALSE;
	}

	//;Base64û룺
	szPassword.Format("%s\r\n", Base64.Encode(m_strPassword, lstrlen(m_strPassword)));
	m_wsSMTPServer.Send((LPCTSTR)szPassword, szPassword.GetLength());
	if(!get_response(AUTH_SUCCESS))
	{
		m_wsSMTPServer.Close();
		delete response_buf;
		response_buf = NULL;
		return FALSE;
	}

	return TRUE;
}

//****************************************
// ܣ÷Ϣ
//****************************************
BOOL CSMTP::get_response(UINT response_expected)
{
	ASSERT(response_expected >= GENERIC_SUCCESS);
	ASSERT(response_expected < LAST_RESPONSE);

	CString sResponse;
	UINT response;
	response_code *pResp;

	if(m_wsSMTPServer.Receive(response_buf, RESPONSE_BUFFER_SIZE) == SOCKET_ERROR)
	{
		m_sError = _T("׽ִ");
		return FALSE;
	}

	sResponse = response_buf;
	sscanf((LPCTSTR)sResponse.Left(3), _T("%d"), &response);
	pResp = &response_table[response_expected];
	if(response != pResp->nResponse)
	{
		m_sError.Format(_T("%d:%s"), response, (LPCTSTR)pResp->sMessage);
		return FALSE;
	}

	return TRUE;
}

CString CSMTP::GetServerHostName()
{
	return m_sSMTPServerHostName;
}

UINT CSMTP::GetPort()
{
	return m_nPort;
}

BOOL CSMTP::SendMessage()
{
	ASSERT(msg != NULL);

	if(!m_bConnected)
	{
		m_sError = _T("ȴӣ");
		return FALSE;
	}

	if(transmit_message() == FALSE)
	{
		return FALSE;
	}

	return TRUE;
}

//****************************************
// ܣɲʼ
//****************************************
BOOL CSMTP::transmit_message()
{
	CString szFrom;
	CString szTo;
	CString szDateTime;
	CString szSubject;
	CString szBodyHead;
	CString szBody;
	CString szContent;
	CString szAttachment;
	CString szTemp;
	CBase64 Base64;

	ASSERT(msg != NULL);

	if(!m_bConnected)
	{
		m_sError = _T("ȴӣ");
		return FALSE;
	}

	//HeaderеġMAIL FROM
	szFrom.Format(_T("MAIL FROM:<%s>\r\n"), (LPCTSTR)m_strFrom);
	m_wsSMTPServer.Send((LPCTSTR)szFrom, szFrom.GetLength());
	if(!get_response(GENERIC_SUCCESS))
	{
		m_wsSMTPServer.Close();
		delete response_buf;
		response_buf = NULL;
		return FALSE;
	}

	//HeaderеġRCPT TO
	szTo.Format(_T("RCPT TO:<%s>\r\n"), (LPCTSTR)m_strTo);
	m_wsSMTPServer.Send((LPCTSTR)szTo, szTo.GetLength());
	if(!get_response(GENERIC_SUCCESS))
	{
		m_wsSMTPServer.Close();
		delete response_buf;
		response_buf = NULL;
		return FALSE;
	}

	//͡DATA\r\n
	m_wsSMTPServer.Send("DATA\r\n", strlen("DATA\r\n"));
	if(!get_response(DATA_SUCCESS))
	{
		m_wsSMTPServer.Close();
		delete response_buf;
		response_buf = NULL;
		return FALSE;
	}

	//½ Body Ĵ
	szFrom.Format(_T("FROM:%s<%s>\r\n"), (LPCTSTR)m_strUsername, (LPCTSTR)m_strFrom);
	szTo.Format(_T("TO:<%s>\r\n"), (LPCTSTR)m_strTo);
	m_tDateTime = m_tDateTime.GetCurrentTime();
	szDateTime = "Date:";
	szDateTime += m_tDateTime.Format("%a, %d %b %Y %H:%M:%S %Z");
	szDateTime += "\r\n";
	szSubject.Format(_T("Subject:%s\r\n"), (LPCTSTR)m_strSubject);
	szBodyHead = "X-Mailer: LCMailer [ch]\r\n";
	szBodyHead += "MIME_Version:1.0\r\n";
	szBodyHead += "Content-type:multipart/mixed;Boundary=www.LuoCong.com\r\n\r\n";
	szBodyHead += "--www.LuoCong.com\r\n";
	szBodyHead += "Content-type:text/plain;Charset=gb2312\r\n";
	szBodyHead += "Content-Transfer-Encoding:8bit\r\n\r\n";
	szBody.Format(_T("%s\r\n\r\n"), (LPCTSTR)m_strBody);

	//½иĴ
	if(m_szFilenames.GetSize() != 0)
	{
		szTemp = "--www.LuoCong.com\r\n";
		szTemp += "Content-Type:application/octet-stream;Name=%s\r\n";
		szTemp += "Content-Disposition:attachment;FileName=%s\r\n";
		szTemp += "Content-Transfer-Encoding:Base64\r\n\r\n";
		szTemp += "%s\r\n\r\n";

		szContent = szFrom + szTo + szDateTime + szSubject + szBodyHead + szBody;
		for(int i = 0; i < m_szFilenames.GetSize(); i++)
		{
			CFile hFile;
			if(hFile.Open(m_szFilenames.GetAt(i), CFile::modeRead))
			{
				DWORD dwFileSize = hFile.GetLength();
				CString szFileBuffer;
				hFile.Read(szFileBuffer.GetBuffer(dwFileSize), dwFileSize);
				szAttachment.Format(szTemp, hFile.GetFileName(), hFile.GetFileName(), Base64.Encode(szFileBuffer, dwFileSize));
				szFileBuffer.ReleaseBuffer();
				hFile.Close();
				szContent += szAttachment;
			}
		}

		//ӳ Content 
		szContent += "--www.LuoCong.com--\r\n.\r\n";
	}
	else
	{
		//ӳ Content 
		szContent = szFrom + szTo + szDateTime + szSubject + szBodyHead + szBody + "--www.LuoCong.com" + "\r\n.\r\n";
	}

	// Content 
	m_wsSMTPServer.Send((LPCTSTR)szContent, szContent.GetLength());
	if(!get_response(GENERIC_SUCCESS))
	{
		m_wsSMTPServer.Close();
		delete response_buf;
		response_buf = NULL;
		return FALSE;
	}

	//͡Quit
	m_wsSMTPServer.Send(_T("QUIT\r\n"), lstrlen(_T("QUIT\r\n")));
	if(!get_response(QUIT_SUCCESS))
	{
		m_wsSMTPServer.Close();
		delete response_buf;
		response_buf = NULL;
		return FALSE;
	}

	return TRUE;
}

//****************************************
// ܣϿ
//****************************************
BOOL CSMTP::Disconnect()
{
	BOOL ret;
	if(!m_bConnected)
		return TRUE;
	CString sQuit = _T("QUIT\r\n");
	m_wsSMTPServer.Send((LPCTSTR)sQuit, sQuit.GetLength());

	ret = get_response(QUIT_SUCCESS);
	m_wsSMTPServer.Close();

	if(response_buf != NULL)
	{
		delete[] response_buf;
		response_buf = NULL;
	}

	m_bConnected = FALSE;
	
	return ret;
}

//****************************************
// ܣô
//****************************************
CString CSMTP::GetLastError()
{
	return m_sError;
}